-------------------------- MODULE Msg ---------------------------
\* This module adds the declaration of different types of messages

(* The hierarchy of the modules are
 Ring (The basic parameters and operations for ring calculation)
   \subset LS (The leaf set utilities)
      \subset RT (The routing table utilities)
         \subset Msg (The messages definitions)
            \subset InitialStates (The initial state and TypeInvariant)
               \subset Actions (All the actions)
                  \subset MSPastry (The specification of MSPastry including propertie
                  \subset MCMSPastry (The model checking file) 
*)
EXTENDS LS
--------------------------------------------------------------
Look == [type : {"Lookup"}, node: I] 
NoLR == [type : {"NoLegalRoute"},  key: I]
JReq == [type : {"JoinRequest"},  node: I] 
JRpl == [type : {"JoinReply"}, lset: LSet] 
Prb  == [type : {"Probe"}, node: I, lset: LSet] 
PRpl == [type : {"ProbeReply"}, node: I, lset: LSet] 
LReq == [type : {"LeaseRequest"}, node: I]
LReply  == [type : {"LeaseReply"}, lset: LSet, grant: BOOLEAN]


MReq == JReq \cup JRpl \cup Prb \cup PRpl \cup Look \cup LReq \cup LReply \cup NoLR
DMsg == [destination: I, mreq: MReq]
==============================================================
